import java.util.*;
import java.io.*;

/**
 * Hanterar en loggfil. Laddar in frn textfil och hller koll p raderna. M.m.
 * @author Pr Thernstrm
 */
public class Loggfil {
    
    // medlemsvariabler
    private Vector vLoggfilsrader = new Vector(); // vector med alla loggfilsrader, som Loggfilsradsobjekt
    private Date datum; // datum och tid d filen laddades in
    private String fil = null; // skvg till filen pfirewall.log.
    private Vector vFelmeddelande = new Vector(); // vector som innehller felmeddelanden vi stter p. bra att ha. Tror denna kan vara bra att ha, helt enkelt.
    private boolean rLaddad = false;
    private int antalRader = 0;
    
    private int antalDrop = 0;
    private int antalSuccess = 0;
    
    Loggfil(String filnamn) {
        fil = filnamn;
    }
    
    Loggfil() {
        // nada
    };
    
    /**
     * Laddar in loggfilen och lgger in alla rader i vLoggfilsrader som objekt av typen Loggfilsrad
     * @return True om loggfilen laddades in. False om inte.
     */
    public boolean laddaLoggfil() {
        
        Vector vRader = new Vector(); // vector med alla loggfilsrader

        vLoggfilsrader.clear(); // rensa, annars lggs allt till i slutet av "gamla" loggfilen
        
        antalRader = 0;
        
        try {
            BufferedReader in = new BufferedReader( new FileReader( fil ) );
            
            String tmp;
            tmp = in.readLine();
            
            // ls in alla rader
            do {
                tmp = in.readLine();
                if (tmp != null)
                    vRader.add(tmp);
            } while (tmp != null);
            
            // stng filen
            in.close();
            
            // skapa ett Loggfilsrad-objekt fr varje rad
            StringTokenizer st;
            Calendar cal = Calendar.getInstance();
            String t1, t2;
            for (int i = 4; i < vRader.size(); i++) { // 4 eftersom vi ska hoppa ver de fem frsta raderna
                
                // mste hmta fram lite info
                // en tokenizer fixar biffen
                st = new StringTokenizer( (String) vRader.get(i) );
                // ska vara 16 tokens, annars e nt fel.
                // 2005: eller 17, som i SP2
                int antalTokens;
                antalTokens = st.countTokens();
                if (antalTokens == 16 || antalTokens == 17) {
                    
                    // de tv frsta r datum
                    // ser ut shr i loggen: 2004-03-14 18:14:03
                    t1 = st.nextToken();
                    t2 = st.nextToken();
                    
                    try {
                        
                        cal.set(Integer.parseInt(t1.substring(0, 4)), (Integer.parseInt(t1.substring(5, 7)))-1, Integer.parseInt(t1.substring(8, 10)), Integer.parseInt(t2.substring(0,2)), Integer.parseInt(t2.substring(3,5)), Integer.parseInt(t2.substring(6,8)) ); // bl, jobbig var den
                        
                        // 2005 fixar 17 tokens x
                        if (antalTokens == 16) {
                            // 16 token = < sp2-loggfil, lmna sista tom
                            vLoggfilsrader.add( new Loggfilsrad( cal.getTime(), st.nextToken(), st.nextToken(), st.nextToken(), st.nextToken(), konverteraTillInt(st.nextToken()), konverteraTillInt(st.nextToken()), konverteraTillInt(st.nextToken()), st.nextToken(), konverteraTillInt(st.nextToken()), konverteraTillInt(st.nextToken()), konverteraTillInt(st.nextToken()), st.nextToken(), st.nextToken(), st.nextToken(), "") );
                        } else {
                            // 17 token
                            vLoggfilsrader.add( new Loggfilsrad( cal.getTime(), st.nextToken(), st.nextToken(), st.nextToken(), st.nextToken(), konverteraTillInt(st.nextToken()), konverteraTillInt(st.nextToken()), konverteraTillInt(st.nextToken()), st.nextToken(), konverteraTillInt(st.nextToken()), konverteraTillInt(st.nextToken()), konverteraTillInt(st.nextToken()), st.nextToken(), st.nextToken(), st.nextToken(), st.nextToken()) );
                        }                      
                        
                        antalRader++;
                    }
                    catch (NumberFormatException e) {
                        vFelmeddelande.add("laddaLoggfil(): " + e);
                        vLoggfilsrader.clear();
                        return false;
                    }
                    
                } else {
                    vFelmeddelande.add("laddaLoggfil(): wrong number of tokens (should be 16 st, but found " + st.countTokens() + ")");
                    return false;
                } // countTokens
                
            }
            
            
        }
        catch (java.io.FileNotFoundException e) {
            vFelmeddelande.add("Fel i laddaLoggfil(): " + e);
            vLoggfilsrader.clear();
            return false;
        }
        catch (java.io.IOException e) {
            vFelmeddelande.add("Fel i laddaLoggfil(): " + e);
            vLoggfilsrader.clear();
            return false;
        }
        catch (Exception e) {
            vFelmeddelande.add("Fel i laddaLoggfil(): " + e);
            vLoggfilsrader.clear();
            return false;
        }
        
        datum = new Date(System.currentTimeMillis()); // datum/tid nr filen laddades
        
        // kommer vi hit s har loggfilen laddats utan problem
        rLaddad = true;
        
        return true;
        
    }
    
    
    /** I loggen s kan t.ex. port vara antingen ett nummer eller ett minustecken ("-")
     * <br>Denna funktion returnerar antingen numret eller -1 om det inte r ett giltigt nummer
     * <br>Detta borde funka eftersom jag aldrig sett vrdet -1 i loggen ngon gng
     * @param s Strng som ska konverteras till nummer
     * @return s fast som nummer om det r ett giltigt nummer, -1 annars
     */
    public Integer konverteraTillInt(String s) {
        Integer nummer;
        try {
            return nummer = Integer.valueOf(s);
        }
        catch (NumberFormatException e) {
            return new Integer(-1);
        }
    }
    
    
    
    /**
     * Returnerar antalet rader (antal loggfilsrader) som finns hmtade
     * @return Antal rader
     */
    public int getAntalRader() {
        //return vLoggfilsrader.size();
        return antalRader;
    }
    
    /** Hmtar en rad frn den inladdade loggen
     * @return Raden
     * @param rad Numret p det rad som ska hmtas
     */
    public Loggfilsrad getRad(int rad) {
        return (Loggfilsrad) vLoggfilsrader.get(rad);
    }
    
    /**
     * Ger det senaste felmeddelandet
     * @return Senaste felmeddelandet
     */
    public String getLastError() {
        return (String) vFelmeddelande.get( vFelmeddelande.size()-1 );
    }
    
    /**
     * Ger skvgen till loggfilen som anvnds av detta objekt
     * @return Skvgen till loggfil som anvnds
     */
    public String getSkvg() {
        return fil;
    }
    
    /**
     * Stter skvg till fil
     * @param skvg Skvg till loggfilen som ska anvndas
     */
    public void setSkvg(String skvg) {
        fil = skvg;
    }
    
    /**
     * r loggen laddad?
     * @return True om filen r laddad. False annars.
     */
    public boolean rLaddad() {
        return rLaddad;
    }
    
    /**
     * Ger datum/tid d loggen lstes in klart
     * @return  Datum/Tid
     */
    public Date getDatumInlst() {
        return datum;
    }
    
    /**
     * Ger antal rader som har action DROP
     * @return Antal rader
     */
    public int getAntalDrop() {
        int antal = 0;
        for (int i = 0; i < vLoggfilsrader.size(); i++) {
            if (((Loggfilsrad) vLoggfilsrader.get(i)).getAction().equals("DROP"))
                antal++;
        }
        return antal;
    }
    
    /**
     * Ger antal rader som har action icke-DROP (successful...)
     * @return Antal rader
     */
    public int getAntalSucess() {
        int antal = 0;
        for (int i = 0; i < vLoggfilsrader.size(); i++) {
            if (!((Loggfilsrad) vLoggfilsrader.get(i)).getAction().equals("DROP"))
                antal++;
        }
        return antal;
    }
    
    // main finns bara fr att testa denna klass!
    /** En main-klass som jag anvnt fr att testa denna klass. Ska inte anvndas!
     * @param args tjong!
     */
    public static void main(String[] args) {
        Loggfil l = new Loggfil();
        l.laddaLoggfil();
        
        
    }
    
    
    
}